/* Database creation, insertion, and population routines
 *   By Charles Shiflett
 *
 * set ts=4 									( 4 character tabs )
 */

#include "post.h"
#include "ieee.h"

/* Basic insert routines used in ieee database
 *
 *  form is func(struct, foreign keys, ... )
 */

void insert_inventory(inventory_type* inv) {
	char buf[BUF_SIZE];
	snprintf(buf, BUF_SIZE, 
	    "INSERT INTO inventory (type, sub_type, size, color, def_price, stock, description, ds) values ('%s','%s','%s','%s','%d.%d','%d','%s',now())",
		inv->type, inv->sub_type, inv->size, inv->color,
		inv->price /100, inv->price % 100 , inv->stock, inv->description);
	exec(buf);
}

void insert_person(persocom* person) {
	char buf[BUF_SIZE], ieee_num[10], user_name[10];

	if (person->ieee_number)
		snprintf(ieee_num, 10, "'%d'", person->ieee_number);
	else 
		snprintf(ieee_num, 10, "NULL");

	if (person->user_name)
		snprintf(user_name, 10, "'%s'", person->user_name);
	else
		snprintf(user_name, 10, "NULL");



	snprintf(buf, BUF_SIZE, 
		"INSERT INTO person (ieee_num, real_name, user_name, password, phone, email, street, zip, city, url, description, ds) values (%s,'%s',%s,'%s','%d','%s','%s','%d','%s','%s','%s', now())",
		ieee_num, person->real_name, user_name, person->password, person->phone, person->email, person->street, person->zip, person->city, person->url, person->description);
	exec(buf);
}

void insert_order(order_type* order, int person) {
	char buf[BUF_SIZE];
	snprintf(buf, BUF_SIZE, 
	    "INSERT INTO order_form (who, paid, delivered, account, description,ds) values ('%d','%s','%s','%s','%s',now())",
		person, order->paid, order->delivered, order->account, order->description);
	exec(buf);
}

void insert_receipt(receipt_type* receipt, int order, int inventory) {
	char buf[BUF_SIZE];
	snprintf(buf, BUF_SIZE, 
		"INSERT INTO receipt (order_num, item_num, price, taxable, description,ds) values ('%d','%d','%d.%d','%d','%s',now())",
		order, inventory, receipt->price/100, receipt->price%100, receipt->tax, receipt->description);
	exec(buf);
}

void insert_expense(expense_type* expense, int person) {
	char buf[BUF_SIZE];
	snprintf(buf, BUF_SIZE, 
		"INSERT INTO expense ( who, account, amount, description, ds ) values ('%d','%s','%d.%d', '%s', now() )",
		person, expense->account, expense->amount/100, expense->amount%100, expense->description );
	exec(buf);
}

void add_expense(int person_num, int amount, char* account, char* description){ 
}

int main() {

	/* Initilize our random number generator based on where in memory we are */
	char memory_location;	
	srand((unsigned int)&memory_location);

	init_database();
	populate();

	return(0);
}
